      PROGRAM DSAEXP
C*************************************************************
C*
C*     PROGRAMA PRINCIPAL
c*
c*   programa para calcular los errores globales (postprocesados
c*   es decir utiliza un polinomio cada dos celdas vecinas de  
C*   grado 3 para CMP2 y grado 5 para CMP3 
c* 
c*
C*************************************************************
C*     NMA=NUMERO DE MATERIALES
C*     NGR=NUMERO DE GRUPOS
C*     NIX=NUMERO DE INTERVALOS EN X
C*     NAS=NUMERO DE ANISOTROPIA:
C*          0 => DISPERSION ISOTROPICA
C*         >0 => DISPERSION ANISOTROPICA
C*     NSN=NUMERO DE DIRECCIONES ANGULARES PARA LA
C*         APROXIMACION
C*         SN(2,4,8,16).
C*     IMP=NUMERO DE PUNTOS DE IMPRESION EN X
C*     NLBC=NUMERO DE CONDICION DE FRONTERA A LA IZQUIERDA:
C*          0 => CONDICION DE FLUJO CERO
C*          1 => CONDICION DE CORRIENTE CERO
C*     NRBC=NUMERO DE CONDICION DE FRONTERA A LA DERECHA:
C*          0 => CONDICION DE FLUJO CERO
C*          1 => CONDICION DE CORRIENTE CERO
C*     IPR=NUMERO DE PROBLEMA:
C*          1 => RESUELVE LA ECUACION DE TRANSPORTE CON FUENTE
C*               EXTERNA, PERO SIN FISIONES.
C*          2 => CALCULA EL NUMERO DE NEUTRONES SECUNDARIOS
C*                  POR
C*               COLISION(FUENTE EXTERNA CERO).
C*          3 => CALCULA EL FACTOR DE MULTIPLICACION EFECTIVA
C*               (FUENTE EXTERNA CERO).
C*     NOPT=NUMERO DE OPCION:
C*          1 =>DIAMOND DIFFERENCE SCHEME
C*          2 =>QUADRATIC CONTINUOUS SCHEME
C*          3 =>CUBIC CONTINUOUS SCHEME
C*     LMAX=NUMERO DE TERMINOS DE LA EXPANSION POR POLINOMIOS
C*          DE LEGENDRE DE LAS DISPERSIONES:
C*          1 =>DISPERSION ISOTROPICA
C*         >1 =>DISPERSION ANISOTROPICA
C*
C*
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION A(40000),NC(8000)
       IFIMAX=40000
   10  READ(5,*)NMA,NGR,NIX,NAS,NSN,IMP,NLBC,NRBC,LMAX,IPR,NOPT
       IF(NMA.EQ.0) GO TO 45
       WRITE(6,200)NMA,NGR,NIX,NAS,NSN,IMP,NLBC,NRBC,LMAX,IPR,NOPT
       CALL NLOGIC(N1,N2,N3,NOPT)
       RN=1.D0
       NIXA=IABS(NIX)
       NPX=NIXA+1
       NGR2=NGR*NGR
       IST=1
       ISS=IST+NGR*NMA
       ISF=ISS+NGR*NMA*NGR*LMAX
       IXP=ISF+NGR*NMA
       IX=IXP+NGR*NMA
       IQ=IX+NPX
       IFMU=IQ+NGR*NMA*LMAX
       IWMU=IFMU+NSN
       IFO=IWMU+NSN
       IFN=IFO+NPX*NGR*NSN
       IFT=IFN+NPX*NGR*NSN
       IFPO=IFT+NGR*NPX
       IFPN=IFPO+NGR*NSN*NIXA*N2
       IFPOX=IFPN+NGR*NSN*NIXA*N2
       IFPNX=IFPOX+NGR*NSN*NIXA*N3
       IS0=IFPNX+NGR*NSN*NIXA*N3
       IS1=IS0+NIXA*NGR*NSN
       IS2=IS1+NIXA*NGR*NSN*N2
       IXIMP=IS2+NIXA*NGR*NSN*N3
       IFIMP=IXIMP+IMP
       IVN=IFIMP+IMP*NGR*NSN
       IVPN=IVN+NPX*NGR*NSN
       IVPNX=IVPN+NIXA*NGR*NSN*N2
       IR0=IVPNX+NIXA*NGR*NSN*N3
       IR1=IR0+NIXA/2
       IR2=IR1+NIXA/2
       IR3=IR2+NIXA/2
       IVT=IR3+NIXA/2
       IF(IVT.GT.IFIMAX) STOP
       ITEX=0
       ITIN=0
C*
C*  LECTURA DE LOS PARAMETROS DE ENTRADA.
C*
       CALL INPUT(NMA,NIX,NIXA,NPX,NGR,NSN,NGR2,A(IST),A(ISS),A(ISF),
     1 A(IXP),NC,A(IFMU),A(IWMU),A(IX),A(IQ),EPSL,EPSR,LMAX)
C*
C*  CALCULO DE LOS VECTORES DE ENTRADA.
C*
       CALL INVAL(NPX,NGR,NSN,NIXA,NOPT,A(IFO),A(IFN),
     1 A(IFPO),A(IFPN),A(IFPOX),A(IFPNX),A(IVN),A(IVPN),
     2 A(IVPNX),NLBC,NRBC)
C*
   20  ITEX=ITEX+1
       RO=RN
       IF(IPR.EQ.1) GO TO 30
       ITIN=0
   30  CALL EQUAL(NPX,NGR,NSN,NIXA,NOPT,A(IVN),A(IFN),A(IVPN),
     1 A(IFPN),A(IVPNX),A(IFPNX))
   40  CONTINUE
C*
C*  CALCULO DE LOS TERMINOS DE FUENTE S0,S1,S2...,PARA CADAPUNTO,
C*  GRUPO Y DIRECCION ANGULAR.
C*
       CALL NUMIN(NMA,NIXA,NPX,NGR,NSN,NOPT,NGR2,A(IST),A(ISS),
     1 NC,A(IFMU),A(IWMU),A(IX),A(IQ),A(ISF),A(IXP),A(IFN),A(IS0),A(IS1)
     2 ,A(IS2),LMAX,ITEX,A(IFPN),A(IFPNX),A(IVN),A(IVPN),A(IVPNX))
   50  ITIN=ITIN+1
C*
C*  CALCULO DEL FLUJO DE NEUTRONES EN CADA PUNTO,GRUPO Y DIRECCION
C*  ANGULAR.
C*
       CALL AFLUX(NMA,NIXA,NPX,NGR,NSN,NOPT,A(IST),NC,A(IFMU),A(IX),
     1 A(IFN),A(IS0),A(IS1),A(IS2),NLBC,NRBC,A(IFPN),A(IFPNX))
C*
C*  CALCULO DEL ERROR ENTRE DOS APROXIMACIONES SUCESIVAS.
C*
       CALL ERROR(NPX,NGR,NSN,NIXA,NOPT,A(IFO),A(IFN),A(IFPO),A(IFPN)
     1 ,A(IFPOX),A(IFPNX),EMAX)
C*
C*  INICIALIZACION PARA LA PROXIMA ITERACION.
C*
       CALL EQUAL(NPX,NGR,NSN,NIXA,NOPT,A(IFO),A(IFN),A(IFPO),
     1 A(IFPN),A(IFPOX),A(IFPNX))
       IF(ITIN.GT.500) GO TO 60
       IF(EMAX.GT.EPSL.AND.IPR.EQ.3) GO TO 40
       IF(EMAX.GT.EPSL.AND.IPR.EQ.2) GO TO 50
       IF(EMAX.GT.EPSL.AND.IPR.EQ.1) GO TO 20
C*
C*  CALCULO DE LA RAPIDEZ DE REACCIONES.
C*
   60 RRFS=RR(NMA,NIXA,NPX,NGR,NSN,NOPT,IPR,A(IX),NC,A(IFMU),A(IFN),
     1 A(IS0),A(IS1),A(IS2),A(ISF),A(IWMU),NGR2,A(IFPN),A(IFPNX))
       IF(IPR.EQ.2) Q=1.D0/RN
       IF(IPR.EQ.3) Q=1.D0/RRFS
       IF(IPR.EQ.2) WRITE(6,300)RN,ITIN,ITEX
       IF(IPR.EQ.3) RN=RRFS
       IF(IPR.EQ.3) WRITE(6,400)RN,ITIN,ITEX
       IF(IPR.EQ.1) GO TO 70
       CALL MULTI(NIXA,NPX,NGR,NSN,NOPT,A(IFN),
     1 A(IFPN),A(IFPNX),Q)
       IF(DABS((RN-RO)/RN).GT.EPSR) GO TO 20
C*
  70  continue
C*
       DO 88 I=1,NMA*NGR
       A(ISF+I-1)=A(ISF+I-1)/RN
   88  CONTINUE
       DO 89 I=1,NSN*NGR*NIXA
       A(IFPN+I-1)=A(IFPN+I-1)*RN
       A(IFPNX+I-1)=A(IFPNX+I-1)*RN
   89  CONTINUE
       RRFN=RR(NMA,NIXA,NPX,NGR,NSN,NOPT,IPR,A(IX),NC,A(IFMU),A(IFN),
     1 A(IS0),A(IS1),A(IS2),A(ISF),A(IWMU),NGR2,A(IFPN),A(IFPNX))
c*
       N2=NIXA/2
       CALL INPOL(NMA,NIXA,NPX,NGR,NSN,IMP,RLM,NOPT,A(IX),NC,
     1 a(ifmu),A(IFN),A(IS0),A(IS1),A(IS2),A(IST),a(iXIMP),XMAX,XMIN,
     2 a(ifimp),A(IFPN),A(IFPNX),A(IWMU),EN0,EN1,EN2,EN3,A(IR0),A(IR1),
     3 a(ir2),a(ir3),N2)
C*
C*  CALCULO DEL FLUJO DE NEUTRONES ESCALAR.
C*
       CALL TFLUX(IMP,NGR,NSN,A(IWMU),A(IFIMP),A(IFT))
C*
 80    CONTINUE
C*
       GO TO 10
 45    CONTINUE
       STOP
C*
C*  FORMATOS DE ENTRADA Y SALIDA.
C*
 100   FORMAT(2I2,I3,2I2,I3,5I2)
 200   FORMAT(/,3X,'NUMERO DE MATERIALES=',I2,10X,'NUMERO DE GRUPOS=',I2
     1 ,/,3X,'NUMERO DE INTERVALOS=',I3,10X,'NUMERO DE ANISOTROPIA=',I2
     2 ,/,3X,'NUMERO DE DIRECCIONES ANGULARES=',I2,/
     3 ,3X,'NUMERO DE PUNTOS DE IMPRESION=',I3,/
     4 ,3X,'NLBC=',I2,10X,'NRBC=',I2,10X,'LMAX=',I2,/
     5 ,3X,'NUMERO DE PROBLEMA=',I2,10X,'NUMERO DE OPCION=',I2,/)
 300   FORMAT(3X,'NUM. DE NEUT. SEC. POR COLISION=',D18.10
     1 ,3X,'ITIN=',I3,3X,'ITEX=',I3)
 400   FORMAT(3X,'FACTOR DE MULT. EFECT.=',D20.10,3X,'ITIN=',I3,3X,'ITEX
     1 =',I3)
       END
C************************************************************
C*
       SUBROUTINE AFLUX(NMA,NIXA,NPX,NGR,NSN,NOPT,ST,NC,FMU,X,FN,S0,
     1 S1,S2,NLBC,NRBC,FPN,FPNX)
C*
C*************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION ST(NGR,NMA),NC(NIXA),FMU(NSN),X(NPX),FN(NPX,NGR,NSN),
     1 S0(NIXA,NGR,NSN),S1(NIXA,NGR,NSN),S2(NIXA,NGR,NSN),
     2 FPN(NIXA,NGR,NSN),FPNX(NIXA,NGR,NSN)
       DO 1000 K=1,NSN
       DO 1000 J=1,NGR
       DO 900 I=1,NIXA
       L=I
       IF(K.GT.NSN/2)L=NIXA+1-I
       NCO=NC(L)
       XL=X(L)
       XR=X(L+1)
       DX=XR-XL
       EI=ST(J,NCO)*DX/FMU(K)
       GO TO(100,700,800),NOPT
C*
C*DIAMOND-DIFFERENCE SCHEME
C*
 100   IF(K.GT.NSN/2)GOTO 150
       IF(EI.EQ.0.D0)GOTO 110
       FN(L+1,J,K)=((2.D0-EI)*FN(L,J,K)+2.D0*EI*S0(L,J
     1 ,K)/ST(J,NCO))/(2.D0+EI)
       GOTO 900
 110   FN(L+1,J,K)=FN(L,J,K)+DX*S0(L,J,K)/FMU(K)
       GOTO 900
 150   IF(EI.EQ.0.D0) GOTO 160
       FN(L,J,K)=((2.D0+EI)*FN(L+1,J,K)-2.D0*EI*S0(L,J
     1 ,K)/ST(J,NCO))/(2.D0-EI)
        GO TO 900
 160   FN(L,J,K)=FN(L+1,J,K)-DX*S0(L,J,K)/FMU(K)
       GOTO 900
C*
C*QUADRATIC CONTINUOUS SCHEME
C*
 700   IF(K.GT.NSN/2)GO TO 750
       IF(EI.EQ.0.D0)GOTO 710
       FN(L+1,J,K)=(12.D0-6.D0*EI+EI*EI)*FN(L,J,K)+2*EI*(6.D0*
     1 S0(L,J,K)+EI*S1(L,J,K))/ST(J,NCO)
       FN(L+1,J,K)=FN(L+1,J,K)/(12.D0+6.D0*EI+EI*EI)
       FPN(L,J,K)=(12.D0*FN(L,J,K)+EI*((6.D0+EI)*S0(L,J,K)
     1 -2.D0*S1(L,J,K))/ST(J,NCO))/(12.D0+6.D0*EI+EI*EI)
       GO TO 900
 710   FN(L+1,J,K)=FN(L,J,K)+DX*S0(L,J,K)/FMU(K)
       FPN(L,J,K)=FN(L,J,K)+DX*(3.D0*S0(L,J,K)-S1(L,J,K))
     1 /(6.D0*FMU(K))
       GOTO 900
 750   IF(EI.EQ.0.D0)GOTO 760
       FN(L,J,K)=(12.D0+6.D0*EI+EI*EI)*FN(L+1,J,K)-2*EI*(6.D0*
     1 S0(L,J,K)+EI*S1(L,J,K))/ST(J,NCO)
       FN(L,J,K)=FN(L,J,K)/(12.D0-6.D0*EI+EI*EI)
       FPN(L,J,K)=(12.D0*FN(L+1,J,K)-EI*((6.D0-EI)*S0(L,J,K)
     1 +2.D0*S1(L,J,K))/ST(J,NCO))/(12.D0-6.D0*EI+EI*EI)
       GO TO 900
 760   FN(L,J,K)=FN(L+1,J,K)-DX*S0(L,J,K)/FMU(K)
       FPN(L,J,K)=FN(L+1,J,K)+DX*(3.D0*S0(L,J,K)+S1(L,J,K))
     1 /(6.D0*FMU(K))
       GOTO 900
C*
C*CUBIC CONTINUOUS SCHEME
C*
 800   IF(K.GT.NSN/2)GOTO 850
       IF(EI.EQ.0.D0)GOTO 810

       FN(L+1,J,K)=(120.D0-60.D0*EI+12.D0*EI*EI-EI*EI*EI)*FN(L,J,K)+
     1 2.D0*EI*((60.D0+EI*EI)*S0(L,J,K)+10.D0*EI*S1(L,J,K)+EI*EI*S2(L,J
     2 ,K))/ST(J,NCO)
       FN(L+1,J,K)=FN(L+1,J,K)/(120.D0+60.D0*EI+12.D0*EI*EI+EI*EI*EI)
       FPN(L,J,K)=2.D0*(60.D0+EI*EI)*FN(L,J,K)+2.D0*EI*((60.D0+10.D0*EI+
     1 EI*EI)*S0(L,J,K)*.5D0-10.D0*S1(L,J,K)-EI*S2(L,J,K))/ST(J,NCO)
       FPN(L,J,K)=FPN(L,J,K)/(120.D0+60.D0*EI+12.D0*EI*EI+EI*EI*EI)
       FPNX(L,J,K)=-20.D0*EI*FN(L,J,K)+EI*(60.D0*S0(L,J,K)+(12.D0*EI+
     1 EI*EI)*S1(L,J,K)-6.D0*(2.D0+EI)*S2(L,J,K))/(3*ST(J,NCO))
       FPNX(L,J,K)=FPNX(L,J,K)/(120.D0+60.D0*EI+12.D0*EI*EI+EI*EI*EI)
       GO TO 900
 810   FN(L+1,J,K)=FN(L,J,K)+DX*S0(L,J,K)/FMU(K)
       FPN(L,J,K)=FN(L,J,K)+DX*(3.D0*S0(L,J,K)-S1(L,J,K))/(6.D0*FMU(K))
       FPNX(L,J,K)=DX*(5.D0*S0(L,J,K)-S2(L,J,K))/(30.D0*FMU(K))
       GO TO 900
 850   IF(EI.EQ.0.D0)GOTO 860
       FN(L,J,K)=(120.D0+60.D0*EI+12.D0*EI*EI+EI*EI*EI)*FN(L+1,J,K)
     1 -2.D0*EI*((60.D0+EI*EI)*S0(L,J,K)+10.D0*EI*S1(L,J,K)+EI*EI*
     2 S2(L,J,K))/ST(J,NCO)
       FN(L,J,K)=FN(L,J,K)/(120.D0-60.D0*EI+12.D0*EI*EI-EI*EI*EI)
       FPN(L,J,K)=2.D0*(60.D0+EI*EI)*FN(L+1,J,K)-2.D0*EI*((60.D0-10.D0*
     1 EI+EI*EI)*S0(L,J,K)*.5D0+10.D0*S1(L,J,K)+EI*S2(L,J,K))/ST(J,NCO)
       FPN(L,J,K)=FPN(L,J,K)/(120.D0-60.D0*EI+12.D0*EI*EI-EI*EI*EI)
       FPNX(L,J,K)=-20.D0*EI*FN(L+1,J,K)-EI*(-60.D0*S0(L,J,K)+(-12*EI+EI
     1 *EI)*S1(L,J,K)+6.D0*(2.D0-EI)*S2(L,J,K))/(3.D0*ST(J,NCO))
       FPNX(L,J,K)=FPNX(L,J,K)/(120.D0-60.D0*EI+12.D0*EI*EI-EI*EI*EI)
       GO TO 900
 860   FN(L,J,K)=FN(L+1,J,K)-DX*S0(L,J,K)/FMU(K)
       FPN(L,J,K)=FN(L+1,J,K)+DX*(3.D0*S0(L,J,K)+S1(L,J,K))/
     1 (6.D0*FMU(K))
       FPNX(L,J,K)=DX*(5.D0*S0(L,J,K)-S2(L,J,K))/(30.D0*FMU(K))
       GOTO 900
 900   CONTINUE
       M=K
       N=NSN-K+1
       IF(NLBC.EQ.1.AND.K.GT.NSN/2)GO TO 910
       GO TO 930
 910   FN(1,J,N)=FN(1,J,M)
 930   IF(NRBC.EQ.1.AND.K.LE.NSN/2)GO TO 940
       GO TO 960
 940   FN(NPX,J,N)=FN(NPX,J,M)
 960   CONTINUE
 1000  CONTINUE
       RETURN
       END
C************************************************************
C*
       SUBROUTINE EQUAL(NPX,NGR,NSN,NIXA,NOPT,FO,FN,FPO,FPN,FPOX,FPNX)
C*
C*************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION FO(NPX,NGR,NSN),FN(NPX,NGR,NSN),FPO(NIXA,NGR,NSN),
     1 FPN(NIXA,NGR,NSN),FPOX(NIXA,NGR,NSN),FPNX(NIXA,NGR
     2 ,NSN)
       DO 10 K=1,NSN
       DO 10 J=1,NGR
       DO 10 I=1,NPX
C*       FN(I,J,K)=FN(I,J,K)+W*(FN(I,J,K)-FO(I,J,K))
       FO(I,J,K)=FN(I,J,K)
 10    CONTINUE
       IF(NOPT.LT.2)RETURN
       DO 50 K=1,NSN
       DO 50 J=1,NGR
       DO 50 I=1,NIXA
C*       FPN(I,J,K)=FPN(I,J,K)+W*(FPN(I,J,K)-FPO(I,J,K))
       FPO(I,J,K)=FPN(I,J,K)
  50   CONTINUE
       IF(NOPT.LT.3)RETURN
       DO 60 K=1,NSN
       DO 60 J=1,NGR
       DO 60 I=1,NIXA
C*       FPNX(I,J,K)=FPNX(I,J,K)+W*(FPNX(I,J,K)-FPOX(I,J,K))
       FPOX(I,J,K)=FPNX(I,J,K)
  60   CONTINUE
       RETURN
       END
C************************************************************
C*
       SUBROUTINE ERROR(NPX,NGR,NSN,NIXA,NOPT,FO,FN,FPO,FPN,FPOX,FPNX,
     1 EMAX)
C*
C************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION FO(NPX,NGR,NSN),FN(NPX,NGR,NSN),FPO(NIXA,NGR,NSN),
     1 FPN(NIXA,NGR,NSN),FPOX(NIXA,NGR,NSN),FPNX(NIXA,NGR
     2 ,NSN)
       EFMAX=DABS(FN(1,1,1)-FO(1,1,1))
       DO 10 K=1,NSN
       DO 10 J=1,NGR
       DO 10 I=1,NPX
       EFIJK=DABS(FN(I,J,K)-FO(I,J,K))
       IF(EFMAX.LT.EFIJK)EFMAX=EFIJK
 10    CONTINUE
       EMAX=EFMAX
       IF(NOPT.LT.2)RETURN
       EPMAX=DABS(FPN(1,1,1)-FPO(1,1,1))
       DO 50 K=1,NSN
       DO 50 J=1,NGR
       DO 50 I=1,NIXA
       EPIJK=DABS(FPN(I,J,K)-FPO(I,J,K))
       IF(EPMAX.LT.EPIJK)EPMAX=EPIJK
 50    CONTINUE
       IF(EMAX.LT.EPMAX)EMAX=EPMAX
       IF(NOPT.LT.3)RETURN
       EPXMAX=DABS(FPNX(1,1,1)-FPOX(1,1,1))
       DO 60 K=1,NSN
       DO 60 J=1,NGR
       DO 60 I=1,NIXA
       EPXIJK=DABS(FPNX(I,J,K)-FPOX(I,J,K))
       IF(EPXMAX.LT.EPXIJK)EPXMAX=EPXIJK
  60   CONTINUE
       IF(EMAX.LT.EPXMAX)EMAX=EPXMAX
       RETURN
       END
C**********************************************************
C*
       FUNCTION FEXAC(X,K)
C*
C*************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       A=DSQRT(6.D0)
       B=3.D0+2.D0*DSQRT(2.D0)
       C=DEXP(-A)+B*DEXP(A)
       IF(K.EQ.1)FEXAC=-(DEXP(X*A)+B*DEXP(-X*A))/C+1.D0
       IF(K.EQ.2)FEXAC=-(B*DEXP(X*A)+DEXP(-X*A))/C+1.D0
       RETURN
       END
C************************************************************
       SUBROUTINE MOMEN(Q0,Q1,Q2,Q3)
c*****************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       A1=DSQRT(6.D0)
       EP=DEXP(A1)
       EM=DEXP(-A1)
       A=-1.D0/(EM+(3.D0+2.D0*DSQRT(2.D0))*EP)
       B=(3.D0+2.D0*DSQRT(2.D0))*A
       X1=1.D0-1.D0/A1
       X2=1.D0+1.D0/A1

       T1=6.D0*A*(1.D0-2.D0*X1/A1)*EP-6.D0*B*(1.D0+2.D0*X2/A1)*EM
       T1=T1/A1
       T2=-6.D0*A*X1*EP+6.D0*B*X2*EM
       T2=T2/A1

       T3=A*(-1.D0+EP)-B*(-1.D0+EM)-12.D0*(A-B)/(A1*A1)-6.D0*(A+B)
     1 /A1
       T3=T3/A1
       Q2=T1+T2+T3
       Q2=Q2*5.D0
       X3=1.D0/A1-2.D0*X1/(A1*A1)
       X4=-1.D0/A1-2.D0*X2/(A1*A1)

       P1=20.D0*A*(1.D0/A1-3.D0*X3/A1)*EP+20.D0*B*(-1.D0/A1+3.D0*X4
     1 /A1)*EM

       P2=-30.D0*A*X3*EP-30.D0*B*X4*EM
       P3=12.D0*A*X1*EP/A1-12.D0*B*X2*EM/A1-A*EP/A1+B*EM/A1

       P4=120*(A+B)/(A1*A1*A1*A1)+60.D0*(A-B)/(A1*A1*A1)+12.D0*(A+B)
     1 /(A1*A1)+(A-B)/A1
       Q3=P1+P2+P3+P4
       Q3=Q3*7.D0
       Q0=A*(EP-1.D0)-B*(EM-1.D0)
       Q0=Q0/A1+1.D0
       Q1=2.D0*A*X1*EP-2.D0*B*X2*EM-A*EP+B*EM
       Q1=Q1/A1+2.D0*(A+B)/(A1*A1)+(A-B)/A1
       Q1=Q1*3.D0
       WRITE(6,*) 'Q0 =',Q0
       WRITE(6,*)'Q1 =',Q1
       WRITE(6,*)'Q2 =',Q2
       WRITE(6,*)'Q3 =',Q3
       RETURN
       END


C***********************************************************
C*
       SUBROUTINE INPOL(NMA,NIXA,NPX,NGR,NSN,IMP,RLM,NOPT
     1 ,X,NC,FMU,FN,S0,S1,S2,ST,XIMP,XMAX,XMIN,FIMP,FPN,FPNX,
     2 WMU,EN0,EN1,EN2,EN3,R0,R1,r2,r3,N2)
C*
C*******************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION FMU(NSN),FN(NPX,NGR,NSN),S0(NIXA,NGR,NSN),
     1  S1(NIXA,NGR,NSN),S2(NIXA,NGR,NSN),NC(NIXA),X(NPX)
     2 ,ST(NGR,NMA),XIMP(IMP),FIMP(IMP,NGR,NSN),FPN(NIXA,NGR,
     3  NSN),FPNX(NIXA,NGR,NSN),WMU(NSN),FU(4),WU(4),r0(n2),r1(N2)
     4 ,r2(n2),r3(n2)
       EN0=1.D0
       EN1=1.D0
       EN2=1.D0
       EN3=1.D0
       FU(1)=.861136311594053D0
       FU(2)=.339981043584856D0
       FU(3)=-.339981043584856D0
       FU(4)=-.861136311594053D0
       WU(1)=0.347854845137454D0*.5D0
       WU(2)=0.652145154862546D0*.5D0
       WU(3)=0.652145154862546D0*.5D0
       WU(4)=0.347854845137454D0*.5D0
       CALL MOMEN(Q0,Q1,Q2,Q3)
       DX=X(2)-X(1)
       EI=ST(1,1)*DX/FMU(1)
       do 33 k=1,nixa/2
       R0(k)=0.D0
       R1(k)=0.D0
       R2(k)=0.D0
       R3(k)=0.D0
   33  continue
       do 2 k=1,nixa/2
       DO 1 I=2*k-1,2*k
       DX=X(I+1)-X(I)
       R0(k)=R0(k)+DX*FPN(I,1,1)
    1  continue
       R0(K)=R0(K)/(2.0*DX)
       if(nopt.eq.2)then
       P1L=0.5d0*(FN(2*K,1,1)-FN(2*K-1,1,1))
       P1R=0.5d0*(FN(2*K+1,1,1)-FN(2*K,1,1))
       else
       P1L=3.d0*fpnx(2*K-1,1,1)
       P1R=3.d0*fpnx(2*K,1,1)
       endif
       P2L=0.5d0*(FN(2*K,1,1)+FN(2*K-1,1,1))-fpn(2*k-1,1,1)
       P2r=0.5d0*(FN(2*K+1,1,1)+FN(2*K,1,1))-fpn(2*k,1,1)
       P3L=0.5d0*(FN(2*K,1,1)-FN(2*K-1,1,1))-3*fpnx(2*k-1,1,1)
       P3r=0.5d0*(FN(2*K+1,1,1)-FN(2*K,1,1))-3*fpnx(2*k,1,1)
       R1(k)=R1(k)+(P1L-3.d0*FPN(2*K-1,1,1))/4.d0
     1 +(P1R+3.d0*FPN(2*K,1,1))/4.d0
       R2(k)=R2(k)+(P2L-5.d0*p1l)/8.d0
     1 +(P2R+5.d0*p1r)/8.d0
       R3(k)=R3(k)+(P3L-7.d0*(p2l-p1l-FPN(2*K-1,1,1)))/16.d0
     1       +(P3r+7.d0*(p2r+p1r-FPN(2*K,1,1)))/16.d0
    2  CONTINUE
       XMAX=X(NPX)
       XMIN=X(1)
       write(*,*)'CMPK CON POSTPROCESAMIENTO EN CADA DOS CELDAS'
       N=1
       DXIMP=(XMAX-XMIN)/FLOAT(IMP-1)
       DO 10 I=1,IMP
       XIMP(I)=XMIN+DXIMP*FLOAT(I-1)
       IF(X(2*N+1).LT.XIMP(I))N=N+1
       DO 10 J=1,NGR
       DO 10 K=1,NSN
       fimp(I,j,k)=FPQ(NMA,NIXA,NPX,NGR,NSN,RLM,NOPT+1,X,NC
     1 ,FMU,FN,S0,S1,S2,ST,N,J,K,XIMP(I),FPN,FPNX,R0(n),R1(N)
     2 ,r2(n),r3(n))
  10   CONTINUE
       EN4=0.D0
       DO 30 I=1,IMP
       FEX=FEXAC(XIMP(I),1)
       EIJK=DABS(fimp(I,1,1)-FEX)
       IF(EIJK.GT.EN4) EN4=EIJK
       write(6,*)ximp(i),fimp(i,1,1),FEX
   30  CONTINUE
       WRITE(6,*)
       WRITE(6,*) 'MAXIMA NORMA POSTPROCESADA'
       WRITE(6,*) 'GLOBALMENTE CADA DOS CELDAS=',EN4
       RETURN
       END



C*************************************************************
C*
       SUBROUTINE INPUT(NMA,NIX,NIXA,NPX,NGR,NSN,NGR2,
     1 ST,SS,SF,XP,NC,
     2 FMU,WMU,X,Q,EPSL,EPSR,LMAX)
C*
C*************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION IC(3),ST(NGR,NMA),SS(NGR2,NMA,LMAX),
     1 SF(NGR,NMA),XP(NGR,
     2 NMA),NC(NIXA),X(NPX),Q(NGR,NMA,LMAX),FMU(NSN),WMU(NSN)
       DO 10 I=1,NMA
       READ(5,*)(ST(J,I),J=1,NGR)
C*     write(6,*)('st=',st(j,i),j=1,ngr)
 10    CONTINUE
       DO 20 L=1,LMAX
       DO 20 I=1,NMA
       KJ=(K-1)*NGR+J
       READ(5,*)(SS(KJ,I,L),KJ=1,NGR2)
C*     write(6,*)('ss=',SS(KJ,I,L),KJ=1,NGR2)
 20    CONTINUE
       DO 25 I=1,NMA
       READ (5,*)(SF(J,I),J=1,NGR)
C*     write(6,*)('sf=',sf(j,i),j=1,ngr)
 25    continue
       DO 28 I=1,NMA
       READ(5,*)(XP(J,I),J=1,NGR)
C*     write(6,*)('xp=',XP(J,I),J=1,NGR)
 28    continue
 30    READ(5,*)IC(1),IC(2),IC(3)
C*     write(6,1250)ic(1),ic(2),ic(3)
       IF(IC(1).EQ.0)GO TO 45
       ICM1=IC(3)-1
       DO 40 M=IC(2),ICM1
       NC(M)=IC(1)
 40    CONTINUE
       GO TO 30
 45    READ(5,*) XI,XF
C*     WRITE(6,1350)XI,XF
       DO 50 I=1,NPX
       X(I)=XI+(I-1)*(XF-XI)/NIXA
 50    CONTINUE
       READ(5,*) EPSL,EPSR
C*     WRITE(6,1450)EPSL,EPSR
       DO 60 L=1,LMAX
       DO 60 I=1,NMA
       READ(5,*)(Q(J,I,L),J=1,NGR)
C*     write(6,*)('q=',Q(J,I,L),J=1,NGR)
 60    continue
       CALL SNDATA(NSN,FMU,WMU)
c*1050  FORMAT(3X,'ST(',I2,',',I2,')=',D8.2)
c* 1150  FORMAT(3X,'SS(',I2,',',I2,',',I2,')=',D8.2)
C1250  FORMAT(3X,'ic1=',i3,', ic2=',I3,', ic3=',I3)
C1350  FORMAT(3X,'XI=',D10.4,3X,'XF=',D10.4)
C1450  FORMAT(3X,'ERROR MAXIMO=',D10.4,5X,'ERROR..=',D10.4)
c* 1550  FORMAT(3X,'Q(',I2,',',I2,',',I2,')=',D8.2)
c* 1850  FORMAT(3X,'SF(',I2,',',I2,')=',D8.2)
c* 1950  FORMAT(3X,'XP(',I2,',',I2,')=',D8.2)
       RETURN
       END
C************************************************************
C*
       SUBROUTINE INVAL(NPX,NGR,NSN,NIXA,NOPT,FO,FN,
     1 FPO,FPN,FPOX,FPNX,VN,VPN,VPNX,NLBC,NRBC)
C*
C***************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION FO(NPX,NGR,NSN),FN(NPX,NGR,NSN),
     1  FPO(NIXA,NGR,NSN),FPN(NIXA,NGR,NSN),
     2   FPOX(NIXA,NGR,NSN),FPNX(NIXA,NGR,NSN)
     3  ,VN(NPX,NGR,NSN),VPN(NIXA,NGR,NSN),VPNX(NIXA,NGR,NSN)
       DO 10 K=1,NSN
       DO 10 J=1,NGR
       DO 10 I=1,NPX
       FO(I,J,K)=1.D0
       VN(I,J,K)=1.D0
 10    CONTINUE
       IF(NOPT.LT.2)GO TO 55
       DO 50 K=1,NSN
       DO 50 J=1,NGR
       DO 50 I=1,NIXA
       FPO(I,J,K)=1.D0
       VPN(I,J,K)=1.D0
  50   CONTINUE
  55   IF(NOPT.LT.3)GO TO 65
       DO 60 K=1,NSN
       DO 60 J=1,NGR
       DO 60 I=1,NIXA
       FPOX(I,J,K)=0.D0
       VPNX(I,J,K)=0.D0
  60   CONTINUE
  65   L=NSN/2
       DO 70 K=1,L
       M=NSN+1-K
       DO 70 J=1,NGR
       IF(NLBC.EQ.0) FO(1,J,K)=0.D0
       IF(NRBC.EQ.0)FO(NPX,J,M)=0.D0
 70    CONTINUE
       CALL EQUAL(NPX,NGR,NSN,NIXA,NOPT,FN,FO,FPN,FPO,
     1 FPNX,FPOX)
       RETURN
       END
C*****************************************************
C*
       SUBROUTINE MINMAX(N,F,FMIN,FMAX)
C*
C*************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION F(N)
       FMIN=F(1)
       FMAX=F(1)
       DO 20 I=2,N
       IF(FMIN.LT.F(I))GO TO 10
       FMIN=F(I)
  10   IF(FMAX.GT.F(I))GO TO 20
       FMAX=F(I)
  20   CONTINUE
       RETURN
       END
C******************************************************
C*
       SUBROUTINE MULTI(NIXA,NPX,NGR,NSN,NOPT,FN,FPN,FPNX,R)
C*
C********************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION FN(NPX,NGR,NSN),FPN(NIXA,NGR,NSN),
     1 FPNX(NIXA,NGR,NSN)
       DO 10 I=1,NPX
       DO 10 J=1,NGR
       DO 10 K=1,NSN
 10    FN(I,J,K)=FN(I,J,K)*R
       IF(NOPT.LT.2)RETURN
       DO 50 I=1,NIXA
       DO 50 J=1,NGR
       DO 50 K=1,NSN
  50   FPN(I,J,K)=FPN(I,J,K)*R
       IF(NOPT.LT.3)RETURN
       DO 60 I=1,NIXA
       DO 60 J=1,NGR
       DO 60 K=1,NSN
  60   FPNX(I,J,K)=FPNX(I,J,K)*R
       RETURN
       END


C************************************************************
C*
       SUBROUTINE NUMIN(NMA,NIXA,NPX,NGR,NSN,NOPT,
     1 NGR2,ST,SS,NC,
     2 FMU,WMU,X,Q,SF,XP,FN,S0,S1,S2,LMAX,ITEX,
     3 FPN,FPNX,VN,VPN,VPNX)
C*
C************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION ST(NGR,NMA),SS(NGR2,NMA,LMAX),NC(NIXA),
     1           FMU(NSN),WMU(NSN),X(NPX),Q(NGR,NMA,LMAX),
     2           FN(NPX,NGR,NSN),S0(NIXA,NGR,NSN),S1(NIXA,NGR,
     3           NSN),S2(NIXA,NGR,NSN),SF(NGR,NMA),
     4           XP(NGR,NMA),
     5           FPN(NIXA,NGR,NSN),FPNX(NIXA,NGR,NSN),
     6           VN(NPX,NGR,NSN),
     7           VPN(NIXA,NGR,NSN),VPNX(NIXA,NGR,NSN)
       DO 10 IP=1,NIXA
       DO 10 IG=1,NGR
       DO 10 ID=1,NSN
       S0(IP,IG,ID)=0.0D0
       IF(NOPT.EQ.1)GO TO 10
       S1(IP,IG,ID)=0.0D0
       IF(NOPT.EQ.2)GO TO 10
       S2(IP,IG,ID)=0.0D0
   10  CONTINUE
       IF(NOPT.GT.1)GO TO 30
       DO 20 IP=1,NIXA
       NCO=NC(IP)
       DX=X(IP+1)-X(IP)
       DO 20 IG=1,NGR
       DO 20 ID=1,NSN
       U=FMU(ID)
       DO 20 L=1,LMAX
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*Q(IG,NCO,L)
       DO 20 N=1,NGR
       M=NSN/2
       DO 20 K=1,M
       NJ=(IG-1)*NGR+N
       W=WMU(K)
       T=FMU(K)
       EI=ST(N,NCO)*DX/T
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)
     2 *(FN(IP,N,K)+FN(IP+1,N,K))*0.5D0
       T=FMU(NSN+1-K)
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)
     2 *(FN(IP,N,NSN+1-K)+FN(IP+1,N,
     3 NSN+1-K))*0.5D0
       IF(L.GT.1)GO TO 20
       S0(IP,IG,ID)=S0(IP,IG,ID)+XP(IG,NCO)*SF(N,NCO)*W*(
     1             VN(IP,N,K)+VN(IP+1,N,K))*0.5D0
       S0(IP,IG,ID)=S0(IP,IG,ID)+XP(IG,NCO)*SF(N,NCO)*W*(
     1             VN(IP,N,NSN+1-K)+VN(IP+1,N,NSN+1-K))*0.5D0
   20  CONTINUE
       RETURN
   30  IF(NOPT.GT.2)GO TO 50
       DO 40 IP=1,NIXA
       DX=X(IP+1)-X(IP)
       NCO=NC(IP)
       DO 40 IG=1,NGR
       DO 40 ID=1,NSN
       U=FMU(ID)
       DO 40 L=1,LMAX
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*Q(IG,NCO,L)
       S1(IP,IG,ID)=S1(IP,IG,ID)+(2*L-1)*P(L,U)
     1 *Q(IG,NCO,L)*0.0D0
       DO 40 N=1,NGR
       M=NSN/2
       DO 40 K=1,M
       NJ=(IG-1)*NGR+N
       W=WMU(K)
       T=FMU(K)
       EI=ST(N,NCO)*DX/T
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)*FPN(IP,N,K)
       S1(IP,IG,ID)=S1(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)
     2 *(-FN(IP,N,K)+FN(IP+1,N,K))*0.5D0
       T=FMU(NSN+1-K)
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)*FPN(IP,N,NSN+1-K)
       S1(IP,IG,ID)=S1(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)
     2 *(-FN(IP,N,NSN+1-K)+FN(IP+1,N,NSN+1-K))*0.5D0
       IF(L.GT.1)GO TO 40
       S0(IP,IG,ID)=S0(IP,IG,ID)+XP(IG,NCO)*
     1 SF(N,NCO)*W*VPN(IP,N,K)
       S0(IP,IG,ID)=S0(IP,IG,ID)+XP(IG,NCO)*SF(N,NCO)*
     1 W*VPN(IP,N,NSN+1-K)
       S1(IP,IG,ID)=S1(IP,IG,ID)+XP(IG,NCO)*SF(N,NCO)
     1 *W*(-VN(IP,N,K)+VN(IP+1,N,K))*0.5D0
       S1(IP,IG,ID)=S1(IP,IG,ID)+XP(IG,NCO)*SF(N,NCO)
     1 *W*(-VN(IP,N,
     2 NSN+1-K)+VN(IP+1,N,NSN+1-K))*0.5D0
   40  CONTINUE
       RETURN
   50  IF(NOPT.GT.3)GO TO 70
       DO 60 IP=1,NIXA
       DX=X(IP+1)-X(IP)
       NCO=NC(IP)
       DO 60 IG=1,NGR
       DO 60 ID=1,NSN
       U=FMU(ID)
       DO 60 L=1,LMAX
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*Q(IG,NCO,L)
       S1(IP,IG,ID)=S1(IP,IG,ID)+(2*L-1)*P(L,U)
     1 *Q(IG,NCO,L)*0.0D0
       S2(IP,IG,ID)=S2(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 Q(IG,NCO,L)*0.0D0
       DO 60 N=1,NGR
       M=NSN/2
       DO 60 K=1,M
       NJ=(IG-1)*NGR+N
       W=WMU(K)
       T=FMU(K)
       EI=ST(N,NCO)*DX/T
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)*FPN(IP,N,K)
       S1(IP,IG,ID)=S1(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)*FPNX(IP,N,K)*3.D0
       S2(IP,IG,ID)=S2(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)
     2 *((FN(IP,N,K)+FN(IP+1,N,K))
     3 *0.5D0-FPN(IP,N,K))
       T=FMU(NSN+1-K)
       S0(IP,IG,ID)=S0(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)*FPN(IP,N,NSN+1-K)
       S1(IP,IG,ID)=S1(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)*FPNX(IP,N,NSN+1-K)*3.D0
       S2(IP,IG,ID)=S2(IP,IG,ID)+(2*L-1)*P(L,U)*
     1 SS(NJ,NCO,L)*W*P(L,T)
     2 *((FN(IP,N,NSN+1-K)+FN(IP+1,N,
     3            NSN+1-K))*0.5D0-FPN(IP,N,NSN+1-K))
       IF(L.GT.1)GO TO 60
       S0(IP,IG,ID)=S0(IP,IG,ID)+XP(IG,NCO)*
     1 SF(N,NCO)*W*VPN(IP,N,K)
       S0(IP,IG,ID)=S0(IP,IG,ID)+XP(IG,NCO)*
     1 SF(N,NCO)*W*VPN(IP,N,NSN+1-K)
       S1(IP,IG,ID)=S1(IP,IG,ID)+XP(IG,NCO)*
     1 SF(N,NCO)*W*VPNX(IP,N,K)*3.D0
       S1(IP,IG,ID)=S1(IP,IG,ID)+XP(IG,NCO)*
     1 SF(N,NCO)*W*VPNX(IP,N,NSN+1-K)*3.D0
       S2(IP,IG,ID)=S2(IP,IG,ID)+XP(IG,NCO)*SF(N,NCO)*W*((
     1             VN(IP,N,K)+VN(IP+1,N,K))*0.5D0-VPN(IP,N,K))
       S2(IP,IG,ID)=S2(IP,IG,ID)+XP(IG,NCO)*SF(N,NCO)*W*((
     1             VN(IP,N,NSN+1-K)+VN(IP+1,N,NSN+1-K))*0.5D0
     2            -VPN(IP,N,NSN+1-K))
   60  CONTINUE
       RETURN
   70  WRITE(6,100)NOPT
       RETURN
  100  FORMAT(/,10X,'ESTE CASO NO EXISTE NOPT=',3X,I3,/)
       END
*******************************************************
C*
       SUBROUTINE NLOGIC(N1,N2,N3,NOPT)
C*
C*****************************************************
       N1=1
       N2=1
       IF(NOPT.LT.2)N2=0
       N3=1
       IF(NOPT.NE.3)N3=0
       RETURN
       END
C******************************************************
C*
       FUNCTION RR(NMA,NIXA,NPX,NGR,NSN,NOPT,IPR,X,NC,FMU,FN,
     1 S0,S1,S2,SF,WMU,NGR2,FPN,FPNX)
C*
C*********************************************************
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DIMENSION FMU(NSN),WMU(NSN),FN(NPX,NGR,NSN),
     1 S0(NIXA,NGR,NSN),S1(NIXA,NGR,NSN),S2(NIXA,NGR,NSN),
     2 NC(NIXA),X(NPX),SF(NGR,NMA),FPN(NIXA,NGR,NSN),
     3 FPNX(NIXA,NGR,NSN)
       IF(IPR.EQ.1)RETURN
       RR=0.0D0
       DO 10 I=1,NIXA
       NCO=NC(I)
       DX=X(I+1)-X(I)
       DO 10 N=1,NGR
       DO 10 K=1,NSN
       IF(NOPT.EQ.1)FCN=(FN(I+1,N,K)+FN(I,N,K))*0.5D0
       IF(NOPT.NE.1)FCN=FPN(I,N,K)
       RR=RR+WMU(K)*FCN*DX*SF(N,NCO)
   10  CONTINUE
       RETURN
       END


C************************************************************
C*
       SUBROUTINE SNDATA(NSN,FMU,WMU)
C*
C******************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION FMU(NSN),WMU(NSN)
       IF(NSN.EQ.2)M=1
       IF(NSN.EQ.4)M=2
       IF(NSN.EQ.8)M=3
       IF(NSN.EQ.16)M=4
       GO TO(100,200,300,400),M
 100   FMU(1)=1.D0/DSQRT(3.D0)
       FMU(2)=-1.D0/DSQRT(3.D0)
       WMU(1)= 0.5D0
       WMU(2)=0.5D0
       RETURN
 200   FMU(1)=.861136311594053D0
       FMU(2)=.339981043584856D0
       FMU(3)=-.339981043584856D0
       FMU(4)=-.861136311594053D0
       WMU(1)=0.347854845137454D0*.5D0
       WMU(2)=0.652145154862546D0*.5D0
       WMU(3)=0.652145154862546D0*.5D0
       WMU(4)=0.347854845137454D0*.5D0
       RETURN
 300   FMU(1)=.960289856497536D0
       FMU(2)=.796666477413627D0
       FMU(3)=.525532409916329D0
       FMU(4)=.1834346424956507D0
       FMU(5)=-.183434642495650D0
       FMU(6)=-.525532409916329D0
       FMU(7)=-.796666477413627D0
       FMU(8)=-.960289856497536D0
       WMU(1)=.101228536290376D0*.5D0
       WMU(2)=.222381034453374D0*.5D0
       WMU(3)=.313706645877887D0*.5D0
       WMU(4)=.362683783378362D0*.5D0
       WMU(5)=.362683783378362D0*.5D0
       WMU(6)=.313706645877887D0*.5D0
       WMU(7)=.222381034453374D0*.5D0
       WMU(8)=.101228536290376D0*.5D0
       RETURN
 400   FMU(1)=.989400934991649D0
       FMU(2)=.944575023073232D0
       FMU(3)=.865631202387831D0
       FMU(4)=.755404408355003D0
       FMU(5)=.617876244402643D0
       FMU(6)=.458016777657227D0
       FMU(7)=.281603550779258D0
       FMU(8)=.095012509837637D0
       FMU(9)=-FMU(8)
       FMU(10)=-FMU(7)
       FMU(11)=-FMU(6)
       FMU(12)=-FMU(5)
       FMU(13)=-FMU(4)
       FMU(14)=-FMU(3)
       FMU(15)=-FMU(2)
       FMU(16)=-FMU(1)
       WMU(1)=.027152459411754D0*.5D0
       WMU(2)=.062253523938647D0*.5D0
       WMU(3)=.095158511682492D0*.5D0
       WMU(4)=.124628971255533D0*.5D0
       WMU(5)=.149595988816576D0*.5D0
       WMU(6)=.169156519395002D0*.5D0
       WMU(7)=.182603415044923D0*.5D0
       WMU(8)=.189450610455068D0*.5D0
       WMU(9)=WMU(8)
       WMU(10)=WMU(7)
       WMU(11)=WMU(6)
       WMU(12)=WMU(5)
       WMU(13)=WMU(4)
       WMU(14)=WMU(3)
       WMU(15)=WMU(2)
       WMU(16)=WMU(1)
       RETURN
       END
C*****************************************************
C*
       SUBROUTINE TFLUX(IMP,NGR,NSN,WMU,FIMP,FT)
C*
C*****************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION WMU(NSN),FIMP(IMP,NGR,NSN),FT(IMP,NGR)
       DO 10 I=1,IMP
       DO 10 J=1,NGR
 10    FT(I,J)=0.D0
       DO 20 I=1,IMP
       DO 20 J=1,NGR
       DO 30 K=1,NSN
       FT(I,J)=FT(I,J)+WMU(K)*FIMP(I,J,K)
  30   CONTINUE
  20   CONTINUE
       RETURN
       END


C************************************************************
C*
       FUNCTION FPQ(NMA,NIXA,NPX,NGR,NSN,RLM,NOPT,
     1 X,NC,FMU,FN,S0,
     2 S1,S2,ST,I,J,K,XC,FPN,FPNX,R0,R1,r2,r3)
C*
C*************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       DIMENSION FMU(NSN),FN(NPX,NGR,NSN),S0(NIXA,NGR,NSN),
     1   S1(NIXA,NGR,NSN),S2(NIXA,NGR,NSN),NC(NIXA),X(NPX),
     2   ST(NGR,NMA),FPN(NIXA,NGR,NSN),FPNX(NIXA,NGR,NSN)
       GO TO(100,200,300,400),NOPT
C*
C*DIAMOND DIFFERENCE SCHEME
C*
  100  U0=(XR-XC)/DX
       V0=(XC-XL)/DX
       FPQ=FN(I,J,K)*U0+FN(I+1,J,K)*V0
       RETURN
C*
C*QUADRATIC CONTINUOUS SCHEME
C*
 200   Z=(2.D0*XC-XL-XR)/DX
       U0=(Z-1.D0)*(3.D0*Z+1.D0)*0.25D0
       V0=(Z+1.D0)*(3.D0*Z-1.D0)*0.25D0
       G0=3.D0*(1.D0-Z*Z)*0.5D0
       FPQ=FN(I,J,K)*U0+FN(I+1,J,K)*V0+FPN(I,J,K)*G0
       RETURN
C*
C*CUBIC CONTINUOUS SCHEME
C*
 300   xl=x(2*i-1)
       xr=x(2*i+1)
       dx=xr-xl
       Z=(2.D0*XC-XL-XR)/DX
       U0=(Z-1.D0)*(1.D0-2.D0*Z-5.D0*Z*Z)*0.25D0
       V0=(Z+1.D0)*(5.D0*Z*Z-2.D0*Z-1.D0)*0.25D0
       G0=3.D0*(1.D0-Z*Z)*0.5D0
       H0=5.D0*Z*(1.D0-Z*Z)*0.5D0
       FPQ=FN(2*i-1,j,k)*U0+FN(2*i+1,J,K)*V0+r0*G0+r1*H0
       RETURN
c*
C*     interpolacon de quinto grado.
C*
 400   xl=x(2*i-1)
       xr=x(2*i+1)
       dx=xr-xl
       Z=(2.D0*XC-XL-XR)/DX
       z2=z*z
       U0=(Z-1.D0)*(42.D0*z2-63.D0*Z2*z2-28.D0*Z2*Z
     *    +12.d0*z-3.d0)*0.0625D0
       V0=(Z+1.D0)*(63.D0*Z2*Z2-28.D0*Z2*z-42.D0*z2
     *    +12.d0*z+3.d0)*0.0625D0
       G0=5.d0*(z-1.d0)*(-1.d0-z)*(1.d0+7.d0*z2)*0.125D0
       H0=7.d0*z*(Z+1.d0)*(z-1.d0)*(1+3.d0*z)*(1-3.d0*z)*0.125D0
       uc2=7.d0*(1.d0-z)*(1.d0+z)*(5.d0*z2-1.d0)*0.125d0
       uc3=9.d0*z*(1.d0-z)*(1.d0+z)*(7.d0*z2-3.d0)*0.125d0
       FPQ=FN(2*i-1,j,k)*U0+FN(2*i+1,J,K)*V0+r0*G0+r1*H0
     * +r2*uc2+r3*uc3
       RETURN
       END
C***************************************************************
C*
       FUNCTION P(N,Z)
C*
C****************************************************************
       IMPLICIT DOUBLE PRECISION(A-H,O-Z)
       GO TO(10,20,30,40,50),N
 10    P=1.D0
       RETURN
 20    P=Z
       RETURN
 30    P=0.5D0*(3.D0*Z*Z-1.D0)
       RETURN
 40    P=.5D0*Z*(5.D0*Z*Z-3.D0)
       RETURN
 50    Z2=Z*Z
       P=.125D0*(35.D0*Z2*Z2-30.D0*Z2+3.D0)
       RETURN
       END
